/////////////////////////////////////////////////////////
// LinearLight

varying mediump vec2 vTex;
uniform lowp sampler2D samplerFront;
uniform mediump vec2 srcStart;
uniform mediump vec2 srcEnd;
uniform lowp sampler2D samplerBack;
uniform mediump vec2 destStart;
uniform mediump vec2 destEnd;
void main(void) {
    lowp vec4 front = texture2D(samplerFront, vTex);
    mediump vec2 tex = (vTex - srcStart) / (srcEnd - srcStart);
    lowp vec4 back = texture2D(samplerBack, mix(destStart, destEnd, tex));
    front.r = (front.r > 0.5) ? (back.r + 2.*(front.r-0.5)) : (back.r + 2.*front.r - 1.);
    front.g = (front.g > 0.5) ? (back.g + 2.*(front.g-0.5)) : (back.g + 2.*front.g - 1.);
    front.b = (front.b > 0.5) ? (back.b + 2.*(front.b-0.5)) : (back.b + 2.*front.b - 1.);
    // front.rgb = (back.rgb * front.a) / (1.0 - front.rgb);
    gl_FragColor = front * back.a;
}